#include <cmath>
#include <iostream>
#include <vector>
#include <ctime>
using namespace std;

using integer = int;

int main(int argc, char **argv) 
{
  integer N = 10;
  integer M = 1;
  clock_t debut, fin;
  clock_t start, end;
  double time;

  debut = clock();

  for (int i = 0; i < argc; ++i) 
  {
    if (argv[i] == string("-n"))
      N = stol(argv[i + 1]);
    if (argv[i] == string("-m"))
      M = stol(argv[i + 1]);
  }
  double h = 0.5 * M_PI / (N - 1);
  cout << "Sizes: n= " << N << " ,  m= " << M << " , h= " << h << endl;

  start = clock();
  vector<double> x(N), y(N);
  end = clock();
  time = end - start;
  cout << "Vectors allocated in " << (double)time/CLOCKS_PER_SEC << " s" << endl;

  start = clock();;
  for (integer i = 0; i < N; ++i) 
  {
    x[i] = pow(cos(i * h), 2);
    y[i] = pow(sin(i * h), 2);
  }
  end = clock();
  time = end - start;
  cout << "Vector initialized in " <<  (double)time/CLOCKS_PER_SEC  << " s" << endl;

  start = clock();
  double dotp_tot = 0.0;
  for (integer j = 0; j < M; ++j) 
  {
    double dotp = 0.0;
    for (integer i = 0; i < N; ++i)
      dotp += x[i] * y[i];

    dotp_tot += dotp;
  }
  end = clock();
  time = end - start;
  cout << "dotp_tot= " << dotp_tot << " computed in " <<  (double)time/CLOCKS_PER_SEC  << " s" << endl;

  fin = clock();
  time = fin - debut;
  cout << "Total time: " <<  (double)time/CLOCKS_PER_SEC  << " s" << endl;

  return 0;
}
