#include <iostream>
#include "mpi.h"
#include "omp.h"
using namespace std ;

int main(int argc,char**argv)
{
  MPI_Init(&argc,&argv);

  int wsize;
  MPI_Comm_size(MPI_COMM_WORLD, &wsize);

  int wrank;
  MPI_Comm_rank(MPI_COMM_WORLD, &wrank);

  int NameSize;
  char ProcessorName[MPI_MAX_PROCESSOR_NAME];
  MPI_Get_processor_name(ProcessorName,&NameSize);

  #pragma omp parallel 
  {
    cout << "Hello world from " << ProcessorName << ", process number " << wrank << " thread number " << omp_get_thread_num() 
	 << " out of " << wsize << " processes using " << omp_get_num_threads() << " threads" << endl;
  }
  return MPI_Finalize();
}
